<template>
  <v-group>
    <v-rect :config="node.config.container" />
    <v-text :config="{text: node.name, ...node.config.title}" />
    <v-text
      :config="{text: '\uf00d', ...node.config.close, fill: 'black'}"
      @mousedown="$event.cancelBubble=true"
      @click="deleteNode({index: index, event: $event})"
    />
    <v-group :config="node.config.inputsOrigin()">
      <GraphicPort :port="port" v-for="(port, i) in node.inputs" :key="`out-${i}`" />
    </v-group>
    <v-group :config="node.config.outputsOrigin()">
      <GraphicPort :port="port" v-for="(port, i) in node.outputs" :key="`out-${i}`" />
    </v-group>
    <v-group :config="node.config.paramsContainer">
      <GraphicParam
        v-for="(param, i) in node.params"
        :index="i"
        :param="param"
        :node="node"
        :key="`param-${i}`"
      />
    </v-group>
  </v-group>
</template>
 
<script lang="ts">
import { mapMutations } from 'vuex'
import Vue, { PropType } from 'vue';
import { NodeWrapper } from '@/lib/gui/wrappers/NodeWrapper';
import GraphicPort from "@/components/elements/GraphicPort.vue"
import GraphicParam from '../elements/GraphicParam.vue';

export default Vue.extend({
  name: 'DefaultNode',
  inheritAttrs: true,
  components: { GraphicPort, GraphicParam },
  props: {
    index: Number,
    node: Object as PropType<NodeWrapper>
  },
  methods: {
    ...mapMutations([
      "linkToParam",
      "deleteNode",
      "beginLink",
      "linkToNode",
      "clickOnPort"
    ])
  }
});
</script>

<style scoped>
@font-face {
  font-family: 'FontAwesome';
  src: url('https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.5.0/fonts/fontawesome-webfont.ttf');
  font-weight: normal;
  font-style: normal;
}
</style>